#ifndef PUSB_H
#define PUSB_H


typedef struct pusb_device_t *pusb_device_t;
typedef struct pusb_endpoint_t *pusb_endpoint_t;

pusb_device_t pusb_search_open (int vendorID, int productID);
pusb_device_t pusb_open (const char *path);
int pusb_close (pusb_device_t dev);
int pusb_claim_interface (pusb_device_t dev, int interface);
int pusb_release_interface (pusb_device_t dev, int interface);

int pusb_control_msg (pusb_device_t dev, int request_type, int request,
    int value, int index, unsigned char *buf, int size, int timeout);
int pusb_set_configuration (pusb_device_t dev, int config);
int pusb_set_interface (pusb_device_t dev, int interface, int alternate);

pusb_endpoint_t pusb_endpoint_open (pusb_device_t dev, int epnum, int flags);
int pusb_endpoint_close (pusb_endpoint_t ep);
int pusb_endpoint_get_descriptor (pusb_endpoint_t ep);

int pusb_endpoint_read_bulk (pusb_endpoint_t ep, unsigned char *buf, int size,
    	int timeout);
int pusb_endpoint_write_bulk (pusb_endpoint_t ep, const unsigned char *buf,
		int size, int timeout);
int pusb_endpoint_read_int (pusb_endpoint_t ep, unsigned char *buf, int size);
int pusb_endpoint_read_iso (pusb_endpoint_t ep, unsigned char *buf, int size);


#endif
