#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "smallsem.h"


int
sem_create (key_t key)
{
	int	sem;

	if ((sem = semget(key, 1, IPC_CREAT | IPC_EXCL |0755)) == -1)
		return (-1);

	return (sem);
}

int
sem_init (int sem, int res_cnt)
{
	union semun su;

	su.val = res_cnt;
	
	if (semctl (sem, 0, SETVAL, su) == -1)
		return (-1);
		
	return (0);
}

int
sem_get (key_t key)
{
	int sem;

	if ((sem = semget (key, 1, 0755)) == -1)
		return (-1);
		
	return (sem);
}

int
sem_destroy (int sem)
{
	if (semctl (sem, 0, IPC_RMID, 0) == -1)
		return (-1);

	return (0);
}

int
sem_P (int sem)
{
	struct sembuf sb;

	sb.sem_num = 0;
	sb.sem_op = -1;
	sb.sem_flg = 0;
	
	if (semop (sem, &sb, 1) == -1)
		return (-1);

	return (0);
}

int
sem_V (int sem)
{
	struct sembuf sb;

	sb.sem_num = 0;
	sb.sem_op = 1;
	sb.sem_flg = 0;
	
	if (semop (sem, &sb, 1) == -1)
		return (-1);

	return (0);
}

