#ifndef __SMALLSEM_H__
#define __SMALLSEM_H__

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#elif defined(__linux__) || defined(__NetBSD__)
/* according to X/OPEN we have to define it ourselves */
union semun {
	int val;                    /* value for SETVAL */
	struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
	unsigned short int *array;  /* array for GETALL, SETALL */
	struct seminfo *__buf;      /* buffer for IPC_INFO */
};
#endif

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

extern int sem_create(key_t);
extern int sem_get(key_t);
extern int sem_init(int, int);
extern int sem_destroy(int);
extern int sem_P();
extern int sem_V();

#endif /* __SMALLSEM_H__ */
